#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <stdlib.h>
#include "basics.h"

void die(char *msg,...) {
  va_list args;
  fprintf(stderr,"Fatal error: ");
  va_start(args,msg);
  vfprintf(stderr,msg,args);
  fprintf(stderr,"\n");
  va_end(args);
  exit(1);
}

/* Could replace with a call to conservative gc's alloc */
void *alloc(size_t length) {
  void *a = malloc(length);
  if (!a)
    die("Out of memory");
  return a;
}

char *stralloc(char *s) {
  char *r = (char*) alloc(strlen(s)+1);
  strcpy(r,s);
  return r;
}

